package DX::Action::SetValue;

use DX::Update::SetValue;
use DX::Class;

has target_path => (is => 'ro', required => 1);

has new_value => (is => 'ro', required => 1);

has _update => (is => 'lazy');

sub dry_run {
  my ($self, $hyp) = @_;
  my ($scope, @events) = $self->_update->apply_to($hyp->scope);
  return (
    $hyp->but(
      actions => [ @{$hyp->actions}, $self ],
      scope => $scope
    ),
    @events,
  );
}

sub _build__update {
  my ($self) = @_;
  DX::Update::SetValue->new(
    target_path => $self->target_path,
    new_value => $self->new_value,
  );
}

1;
